#include <acknex.h>

BMAP* ates_map = "ates.tga";
BMAP* sondur_map = "ates.tga";
BMAP* smoke_map = "smoke.tga"; 
BMAP* bar_map = "#200x10x24"; 

VECTOR renk_ilk;
VECTOR renk_son;
VECTOR renk;
function ates_event(PARTICLE* part)
{
    vec_set(renk_ilk,vector(180 ,60 ,0 ));
    vec_set(renk_son,vector(180 ,20 ,0 ));
    vec_lerp(renk,renk_son,renk_ilk,part.lifespan/10 );


    if(part.size!=1) 
     part.size-=time_step*0.2;
     
    part.alpha = part.lifespan/100 *100;
    if(part.alpha<=0) part.lifespan = 0;
}

function ates_fn(PARTICLE* part)
{
    var temp[3];
    part.vel_z += random(3);
    part.y += random(10)-5;
    part.x+=random(10)-5;
 part.red= 180 ; 
 part.green= 60 ; 
 part.blue= 0  ;
   part.size = 10 +random(3);
    part.lifespan =30 ;
    if(part.size>10 +2.7)
    {
        part.size = 1;
        part.lifespan = 50 +5;
        part.y+=2-random(1);
    }
    part.bmap = ates_map;
    part.flags|=(BRIGHT|MOVE|TRANSLUCENT);
    part.event = ates_event;
}


function sondur_event(PARTICLE* part)
{
    vec_set(renk_ilk,vector(100 ,100 ,100 ));
    vec_set(renk_son,vector(50 ,50 ,50 ));
    vec_lerp(renk,renk_son,renk_ilk,part.lifespan/10 );




     
    part.alpha = part.lifespan/100 *100;
    if(part.alpha<=0) part.lifespan = 0;
}

function sondur_fn(PARTICLE* part)
{
    var temp[3];
    part.vel_z -= random(2)+1;
    part.vel_y += random(2)+2;
    part.z += random(4)-2;
    part.y += random(10)-5;
    part.x+=random(10)-5;
 part.red= 50 ; 
 part.green= 50 ; 
 part.blue= 50  ;
   part.size = 10 +random(3);
    part.lifespan =60;
    

    part.bmap = sondur_map;
    part.flags|=(BRIGHT|MOVE|TRANSLUCENT);
    part.event = sondur_event;
}


VECTOR temp;
function fade_duman(PARTICLE *p)

{

       p.alpha -= 0.15 * time_step;

       if (p.alpha < 0) {p.lifespan = 0;}

}

 

function duman_fn(PARTICLE *p)
{
	
 p.red=5;
 p.blue=5;
 p.green=5;
 
       temp.x = random(2) - 1;
       temp.y = random(0.5) - 0.25; 
       temp.z = random(2); 

      vec_add (p.vel_x, temp);
vec_add (p.x, temp);

       p.alpha = 10 + random(20);

      p.bmap = smoke_map;

       p.size = 10;
p.flags|= (BRIGHT | TRANSLUCENT | MOVE | FILTER | LIGHT | BEAM);
 
       p.lifespan = 350; 
       p.event = fade_duman;

}

function pan_ef_event(PARTICLE* part)
{
    part.alpha = part.lifespan/100 *100;
    if(part.alpha<=0) part.lifespan = 0;
}

function pan_ef_fn(PARTICLE* part)
{
    var temp[3];
    part.vel_z += random(2)+1;
    part.vel_y -= random(2)+2;
    part.z += random(4)-2;
    part.y += random(10)-5;
    part.x+=random(10)-5;
    
 part.red= 20 ; 
 part.green= 240 ; 
 part.blue= 20  ;
   part.size = 1 +random(1);
    part.lifespan =60;
    

    part.bmap = sondur_map;
    part.flags|=(BRIGHT|MOVE|TRANSLUCENT);
    part.event = pan_ef_event;
}

PANEL* bar_pan =
{
	bmap=bar_map;
	pos_x=0;
	pos_y=30;
	flags=SHOW;

}
PANEL* aciklama_pan =
{

	pos_x=220;
	pos_y=25;
	flags=SHOW;
digits(0,0,"FIRE LEVEL","Arial#20b",1,0);
digits(-220,-25,"PRESS SPACE TO EXTINGUISH FIRE","Arial#20b",1,0);
}
var a=10;
var ses=10;
var ses2=0;
function main ()
{
	fps_max=60;
	vec_set(sky_color.blue,vector(5,5,5));
	level_load("");
	camera.x-=200;
		camera.z+=50;
you=ent_create("varil.mdl",vector(0,50,10),NULL);
your.ambient=100;  
you=ent_create("sondurucu.mdl",vector(0,-25,65),NULL);
your.ambient=100; 

bmap_fill(bar_map,vector(20,240,20),100);  
    while(1)
    {
        effect(ates_fn,a,vector(0,50,10),normal);
        if(key_space)
        {
       if(a>1)
        	a-=time_step*0.1;
        	
        	effect(sondur_fn,5,vector(0,-25,65),normal);
        	if(ses>10)
        	{
ses=0;
        	media_play("sprey.wav",NULL,10);
}   
ses+=time_step*2;  
effect(pan_ef_fn,a,vector(0,(a*-5)+110,127),normal);
}

	if(a>1&&key_space==0)
	{
	a+=time_step*0.5;
}
if(a<1)
{
	a=0.1;
	effect(duman_fn,2,vector(0,50,10),normal);
}
else
{
	        	if(ses2>10)
        	{
ses2=0;
        	media_play("ates.wav",NULL,10);
}   
ses2+=time_step*2;  
}
a=clamp(a,0.1,10);
bar_pan.scale_x=a/10;
        wait(1);
    }
}

